package org.rcisoft.business.bslschedule.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.bslschedule.entity.BSlSchedule;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
* Created with  on 2018-5-2 16:39:34.
*/
@Repository
public interface BSlScheduleRepository extends BaseMapper<BSlSchedule> {

    /**
    * 分页查询 bSlSchedule
    *
    */
    @Select("<script>select * from b_sl_schedule where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BSlSchedule> queryBSlSchedules(BSlSchedule bSlSchedule);

    @Select("<script>select *, s_user.name as teacherName,"
            + "b_agency.name as agencyName,b_agency.code as agencyCode,b_agency.business_id as agencyId, \n"
            + "b_lesson.code as lessonCode,b_direction.name as directionName,b_direction.code as directionCode, \n"
            + "b_sl.code as bslCode, \n"
            + "(select sum(student_num) from b_class where FIND_IN_SET(b_class.code,b_edu_class.classes_id)) AS studentNum from b_sl_schedule "
            + "left join b_sl on b_sl_schedule.tea_code = b_sl.teacher_code and b_sl_schedule.term_code = b_sl.term_code and b_sl_schedule.lesson_code = b_sl.lesson_code \n"
            + "left join b_edu_class on b_edu_class.code = b_sl_schedule.edu_class_code \n"
            + "left join b_lesson on b_lesson.code = b_sl_schedule.lesson_code \n"
            + "left join b_lesson_direction on b_lesson_direction.lession_id = b_lesson.business_id \n"
            + "left join b_direction on b_direction.business_id = b_lesson_direction.direction_id \n"
            + "left join b_rooms on b_rooms.code = b_sl_schedule.room_code \n"
            + "left join s_user on s_user.login_name = b_sl_schedule.tea_code \n"
            + "left join b_teacher on b_teacher.code = b_sl_schedule.tea_code \n"
            + "left join b_agency on b_agency.code = b_teacher.agency_code \n"
            + "where start_day between #{0} and #{1} and sub_agency_id = #{2} order by edu_class_code,start_day,seq"
            + "</script>"
    )
    @ResultMap(value = "BaseResultMap2" )
    List<BSlSchedule> queryMoreBSlSchedules(String minTime,String maxTime,String subAgencyId);

    int insertList(List<BSlSchedule> bSlSchedules);

    @Update("update b_sl_schedule set sl_id = #{slId} where sub_agency_id = #{subAgencyId} and del_flag = 0 and flag = 1")
    int updateSlIdBySubAgencyId(@Param("slId") String slId, @Param("subAgencyId") String subAgencyId);

    @Delete("delete from b_sl_schedule where sub_agency_id = #{subAgencyId}")
    int avoidRepeatBSlSchedule(String subAgencyId);

    @Update("update b_sl_schedule set status = #{status} where sub_agency_id = #{subAgencyId} and del_flag = 0 and flag = 1")
    int updateStatusBySubAgencyId(@Param("subAgencyId") String subAgencyId, @Param("status") String status);

    int countStudentNum(String classesId);

    @Select("select count(*) from b_sl_schedule where room_code = ( select `code` from b_rooms where business_id = #{businessId})")
    int countThisRoomNum(String businessId);

    @Select("select count(*) from b_sl_schedule bs " +
            "left join b_teacher bt on bs.tea_code = bt.code " +
            "where bt.business_id = #{id}")
    int querySlScheduleByTeaCode(String id);

    @Select("select count(*) from b_schedule_dto bs " +
            "left join b_teacher bt on bs.teacher_code = bt.code " +
            "where bt.business_id = #{id}")
    int querySlScheduleDtoByTeaCode(String id);
}

